/*

bit2ascii

author: reinhard@finalmedia.de
26.02.2014

licence: public domain. no warranty.

reading data from stdin, and writing
bitwise and bytewise character "1"
or "0" for upbit, downbit.

use argument "-l" for LOOP mode, if you dont want to
check for eof. this is important when you are
using some streams like /dev/urandom

example usage: ./bit2ascii -l < /dev/urandom

*/

#include <stdio.h>

char c;
int i=0;
int loop=0,flushing=0;

int main(int argc, char *argv[]) {

for (i = 1; i < argc; i++) {
                switch (argv[i][0] == '-' ? argv[i][1] : '?') {
                case 'l':
                        loop=1;
                        break;
                case 'f':
                        flushing=1;
                        break;
		case 'h':
			write(2,"usage: bit2ascii [-l for loop] [-f for flush]\n",48);
			return 0;
                default:
                        return 0;
                }
        }


do
{
c=getc(stdin);

for (i=0; i < 8; i++) { if( (c << i) & 0x80 ) { putc('1',stdout); } else { putc('0',stdout); }}

if (flushing==1) { fflush(stdout); }


} while (c!=EOF || loop==1);

return 0;

}
